//+------------------------------------------------------------------+
//|                                       WPR Strength Histogram.mq4 |
//|                                      Copyright  2016, Crossluck |
//|                                                       20/05.2016 |
//|           : http://forexsystemsru.com/member.php?u=118325 |
//|            email: krokhin.roman.91@lenta.ru | skype: crossing203 |
//+------------------------------------------------------------------+
#property strict
#property indicator_separate_window
#property indicator_buffers 2
#property indicator_color1 Green
#property indicator_width1 2
#property indicator_color2 Red
#property indicator_width2 2
extern string S1="  WPR";
extern int period_wpr=14;//
extern string S2="   WPR";
extern double level_1=-20;// 
extern double level_2=-80;// 
extern string S3=" MA";
extern bool ma_filter=false;// MA
extern int period_ma=14;//
extern ENUM_MA_METHOD ma_method=0;// MA
extern ENUM_APPLIED_PRICE applied_price=0;// 
extern string S4="/";
extern bool ClearAllObjects=false;//    
extern int counted_bars=1000;// 
string LF="\n";
int ObjCount=0;
int current=0;
double up[];
double down[];
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
{
if(ClearAllObjects)ObjectsDeleteAll();
IndicatorShortName("WPR Strength Histogram");
IndicatorDigits(5);
IndicatorBuffers(2);
SetIndexBuffer(0,up);
SetIndexStyle(0,DRAW_HISTOGRAM, STYLE_SOLID);
SetIndexArrow(0,225);
SetIndexBuffer(1,down);
SetIndexStyle(1,DRAW_HISTOGRAM, STYLE_SOLID);
SetIndexArrow(1,226);
return(0);
}
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
{
if(ClearAllObjects)ObjectsDeleteAll();
return(0);
}
//+------------------------------------------------------------------+
//| Custom indicator start function                                  |
//+------------------------------------------------------------------+
int start()
{
Tick();
return(0);
}
//+------------------------------------------------------------------+
void Tick()
{
for(int i=0;i<counted_bars;i++)
{
current=i;
up();
down();
}
}
void up()
{
if(iWPR(NULL,NULL,period_wpr,current+1)>level_1)
{
ma_filter_up();
}
}
void ma_filter_up()
{
if(!ma_filter)histogram_up();
if((ma_filter&&iMA(NULL,0,period_ma,0,ma_method,applied_price,current+1)>iMA(NULL,0,period_ma,0,ma_method,applied_price,current+2))&&(iMA(NULL,0,period_ma,0,ma_method,applied_price,current+1)>iMA(NULL,0,period_ma,0,ma_method,applied_price,current+3)))
{
histogram_up();
}
}
void histogram_up()
{
up[current]=Close[current];
}
void down()
{
if(iWPR(NULL,NULL,period_wpr,current+1)<level_2)
{
ma_filter_down();
}
}
void ma_filter_down()
{
if(!ma_filter)histogram_down();
if((ma_filter&&iMA(NULL,0,period_ma,0,ma_method,applied_price,current+1)<iMA(NULL,0,period_ma,0,ma_method,applied_price,current+2))&&(iMA(NULL,0,period_ma,0,ma_method,applied_price,current+1)<iMA(NULL,0,period_ma,0,ma_method,applied_price,current+3)))
{
histogram_down();
}
}
void histogram_down()
{
down[current]=Close[current];
}